﻿Imports System.Drawing.Drawing2D
Imports System.Drawing.Text
Imports System.ComponentModel
Public Class SPanel
    Inherits Control

    Sub New()
        Font = New Font("Segoe UI Light", 12)
    End Sub

    Protected Overrides Sub OnPaint(pevent As PaintEventArgs)
        pevent.Graphics.Clear(BackColor)
        pevent.Graphics.DrawRectangle(Pens.Gray, 1, 1, Width - 2, Height - 2)

        Dim stringFormat As New StringFormat()
        stringFormat.Alignment = StringAlignment.Near
        stringFormat.LineAlignment = StringAlignment.Near
        pevent.Graphics.DrawString(Text, Font, New SolidBrush(ForeColor), New Rectangle(0, 0, Width - 1, Height - 1), stringFormat)
    End Sub
End Class
