﻿Imports System.Media 'wird benötigt für den SoundPlayer
Public Class frmClock

    Dim hour As String, min As String, sec As String 'für die aktuelle Uhrzeit

    Dim Timehour As String, Timemin As String, Timesec As String 'für die laufzeit seit btnStart gedrückt

    Dim Inthour As Integer, Intmin As Integer, Intsec As Integer 'für die laufzeit seit btnStart gedrückt

    Dim secLeft As String, minLeft As String, hourLeft As String 'für die restliche laufzeit bis "lblClock" und "UltTime" sich gleichen, wird ausgegeben in "lblTimeLeft"

    Dim intSecLeft As Integer, intMinLeft As Integer, intHourLeft As Integer 'für die restliche laufzeit bis "lblClock" und "UltTime" sich gleichen, wird ausgegeben in "lblTimeLeft"

    Dim clockHour As String, clockMin As String, clockSec As String, UltTime As String 'damit der String mit dem label verglichen werden kann

    Dim btnPass As Boolean = False, shouldTmrStart As Boolean = False 'Übergangsvariable damit der btnStart auch wirklich starten darf

    Dim firstTick As Boolean = False 'Übergangsvariable, dient zur synchronisation von: "lblClock", "lblTimeAgo" und "lblTimeLeft"

#Region "MenuStripItems"
    Private Sub itmOption_Click(sender As Object, e As EventArgs) Handles itmOption.Click
        Dim options As New frmOption
        options.frm = "frmClock"
        options.Show()
        Me.Hide()
    End Sub

    Private Sub itmExit_Click(sender As Object, e As EventArgs) Handles itmExit.Click
        Application.Exit()
    End Sub

    Private Sub itmStoptimer_Click(sender As Object, e As EventArgs) Handles itmStoptimer.Click
        Dim stoptimer As New frmStoptimer
        stoptimer.Show()
        Me.Hide()
    End Sub

    Private Sub itmTimer_Click(sender As Object, e As EventArgs) Handles itmTimer.Click
        Dim timer As New frmTimer
        timer.Show()
        Me.Hide()
    End Sub
#End Region

    Private Sub tmr_Tick(sender As Object, e As EventArgs) Handles tmr.Tick 'Dient zur ständigen Überprüfung von lblClock und lblTime
        If firstTick = True Then
            tmr.Interval = 1000
        ElseIf firstTick = False Then
            firstTick = True
        End If

        If shouldTmrStart = True Then
            LayoutClockSettings()

            If UltTime.Equals(lblClock.Text) Then
                ResetTimerAgo()
                ResetTimeLeft()
                btnStart.Enabled = False
                player()
            End If
            Intsec += 1
            TimeAgo()
            LayoutTimeLeft()
            lblTimeAgo.Text = Timehour & ":" & Timemin & ":" & Timesec
        End If
        ClockString()

        lblClock.Text = hour & ":" & min & ":" & sec
    End Sub

    Sub player() 'SoundPlayer
        Dim player As New SoundPlayer
        player.Stream = My.Resources.Wecker_klingeln

        player.Load()
        player.Play()

        player.Dispose()
    End Sub

    Sub LayoutClockSettings() 'Wird zu UltTime zusammengeführt zum vergleichen mit lblClock
        Dim intHour As Integer = My.Settings.ClockHour
        Dim intMin As Integer = My.Settings.ClockMin
        Dim intSec As Integer = My.Settings.ClockSec

        If intHour < 10 Then
            clockHour = "0" & intHour.ToString()
        Else
            clockHour = intHour.ToString()
        End If

        If intMin < 10 Then
            clockMin = "0" & intMin.ToString()
        Else
            clockMin = intMin.ToString()
        End If

        If intSec < 10 Then
            clockSec = "0" & intSec.ToString()
        Else
            clockSec = intSec.ToString()
        End If
        UltTime = clockHour & ":" & clockMin & ":" & clockSec
    End Sub

    Sub LayoutTimeLeft() 'rechnet die restliche Zeit aus (vllt. etwas zu kompliziert gelöst, aber es läuft immerhin)
        'BUG: Manchmal 1sek verzögerung + oder -, das variiert
        Dim selHour As Integer = My.Settings.ClockHour
        Dim selMin As Integer = My.Settings.ClockMin
        Dim selSec As Integer = My.Settings.ClockSec

        Dim currentSec As Integer = DateTime.Now.Second, currentMin As Integer = DateTime.Now.Minute, currentHour As Integer = DateTime.Now.Hour

        If intSecLeft = Nothing AndAlso intMinLeft = Nothing AndAlso intHourLeft = Nothing Then
            If selSec >= currentSec Then
                intSecLeft = selSec - currentSec
            Else
                intSecLeft = 60 - currentSec
            End If

            If selMin > currentMin + 1 Then
                intMinLeft = selMin - currentMin - 1
            ElseIf selMin = currentMin Then
                intMinLeft = selMin - currentMin
            Else
                intMinLeft = 60 - currentMin
            End If

            If selHour > currentHour + 1 Then
                intHourLeft = selHour - currentHour - 1
            ElseIf selHour = currentHour Then
                intHourLeft = selHour - currentHour
            Else
                intHourLeft = 0
            End If
        End If

        If intSecLeft = -1 Then
            If Not intMinLeft = 0 Then
                intSecLeft = 59
                intMinLeft -= 1
            ElseIf intMinLeft = 0 Then
                If intHourLeft > 0 Then
                    intHourLeft -= 1
                    intMinLeft = 59
                ElseIf intHourLeft = 0 Then
                    intHourLeft = 0
                    intMinLeft = 0
                    intSecLeft = 0
                End If
            End If
        End If

        If intMinLeft = -1 Then
            If Not intHourLeft = 0 Then
                intMinLeft = 59
                intHourLeft -= 1
            ElseIf intHourLeft = 0 Then
                intHourLeft = 0
                intMinLeft = 0
            End If
        End If

        If intSecLeft < 10 Then
            secLeft = "0" & intSecLeft.ToString
        Else
            secLeft = intSecLeft.ToString()
        End If

        If intMinLeft < 10 Then
            minLeft = "0" & intMinLeft.ToString()
        Else
            minLeft = intMinLeft.ToString()
        End If

        If intHourLeft < 10 Then
            hourLeft = "0" & intHourLeft.ToString()
        Else
            hourLeft = intHourLeft.ToString()
        End If

        lblTimeLeft.Text = hourLeft & ":" & minLeft & ":" & secLeft

        intSecLeft -= 1
    End Sub

    Sub ResetTimeLeft()
        intSecLeft = 0
        intMinLeft = 0
        intHourLeft = 0

        secLeft = ""
        minLeft = ""
        hourLeft = ""
    End Sub

    Sub TimeAgo() 'Zeit die vergeht seitdem btnStart gedrückt wurde

        If Intsec = 60 Then
            Intsec = 0
            Intmin += 1
        End If

        If Intmin = 60 Then
            Intmin = 0
            Inthour += 1
        End If

        If Inthour = 25 Then
            Intsec = 0
            Intmin = 0
            Inthour = 0
            ResetTimerAgo()
            btnStart.Enabled = True
            MessageBox.Show("Error! Too long Runtime!", "Runtime-Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If

        If Inthour < 10 Then
            Timehour = "0" & Inthour.ToString()
        Else
            Timehour = Inthour.ToString()
        End If

        If Intmin < 10 Then
            Timemin = "0" & Intmin.ToString()
        Else
            Timemin = Intmin.ToString()
        End If

        If Intsec < 10 Then
            Timesec = "0" & Intsec.ToString()
        Else
            Timesec = Intsec.ToString
        End If
    End Sub

    Sub ClockString() 'Layout der Clock: wird in tmr_Tick aufgerufen
        If DateTime.Now.Hour < 10 Then
            hour = "0" & DateTime.Now.Hour.ToString()
        Else
            hour = DateTime.Now.Hour.ToString()
        End If

        If DateTime.Now.Minute < 10 Then
            min = "0" & DateTime.Now.Minute.ToString()
        Else
            min = DateTime.Now.Minute.ToString()
        End If

        If DateTime.Now.Second < 10 Then
            sec = "0" & DateTime.Now.Second.ToString()
        Else
            sec = DateTime.Now.Second.ToString()
        End If
    End Sub

    Private Sub frmClock_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing 'wenn das Fenster geschlossen wird, wird das komplette Programm beendet
        Application.Exit()
    End Sub

    Private Sub frmClock_Load(sender As Object, e As EventArgs) Handles MyBase.Load 'wenn die Form geladen wird
        tmr.Start()
    End Sub

    Private Sub btnOptions_Click(sender As Object, e As EventArgs) Handles btnOptions.Click 'wenn der btnOptions gedrückt wird
        Dim frmOpt As New frmOption
        frmOpt.Show()
        frmOpt.frm = "frmClock"
        Me.Hide()
    End Sub

    Sub testforTime() 'Schaut ob die gewählte Zeit des Nutzers unter der aktuellen liegt oder der aktuellen gleicht(wird nur bei btnStart aufgerufen)
        Dim currentHour As Integer = DateTime.Now.Hour
        Dim currentMin As Integer = DateTime.Now.Minute
        Dim currentSec As Integer = DateTime.Now.Second

        Dim SelectedHour As Integer = My.Settings.ClockHour
        Dim SelectedMin As Integer = My.Settings.ClockMin
        Dim SelectedSec As Integer = My.Settings.ClockSec

        If SelectedHour < currentHour Then
            MessageBox.Show("Error! Selected hour is located under current hour!", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        ElseIf SelectedHour > currentHour Then
            btnPass = True
        ElseIf SelectedHour.Equals(currentHour) Then
            If SelectedMin < currentMin Then
                MessageBox.Show("Error! Selected minute is located under current minute!", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            ElseIf SelectedMin > currentMin Then
                btnPass = True
            ElseIf SelectedMin.Equals(currentMin) Then
                If SelectedSec < currentSec Then
                    MessageBox.Show("Error! Selected second is located under current second!", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                ElseIf SelectedSec > currentSec Then
                    btnPass = True
                ElseIf SelectedSec.Equals(currentSec) Then
                    MessageBox.Show("Error! Selected time equals current time!", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If
            End If
        End If
    End Sub

    Private Sub btnStart_Click(sender As Object, e As EventArgs) Handles btnStart.Click 'Wenn btnStart gedrückt wird
        testforTime()
        If btnPass = True Then
            shouldTmrStart = True
            Size = New Size(280, 199)
            MaximumSize = New Size(280, 199)
            MinimumSize = New Size(280, 199)
            btnPass = False
            btnStart.Enabled = False
        End If
    End Sub

    Sub ResetTimerAgo() 'Setzt die Zeit die vergangen ist seitdem btnStart gedrückt wurde zurück
        Inthour = 0
        Intmin = 0
        Intsec = 0
        clockHour = ""
        clockMin = ""
        clockSec = ""
        UltTime = ""
        Timehour = ""
        Timemin = ""
        Timesec = ""
        lblTimeAgo.Text = ""
        shouldTmrStart = False
        Size = New Size(280, 172)
        MaximumSize = New Size(280, 172)
        MinimumSize = New Size(280, 172)
        btnStart.Enabled = True
    End Sub

    Private Sub btnStop_Click(sender As Object, e As EventArgs) Handles btnStop.Click 'Stoppt tmrTimeAgo und gibt btnStart wieder frei um erneutes Anwenden zu ermöglichen
        ResetTimerAgo()
        ResetTimeLeft()
        My.Computer.Audio.Stop()

        Size = New Size(280, 172)
        MaximumSize = New Size(280, 172)
        MinimumSize = New Size(280, 172)
        btnStart.Enabled = True
    End Sub
End Class