﻿Imports System.Media 'für SoundPlayer
Public Class frmTimer
    Dim intsek As Integer, intmin As Integer, inthour As Integer 'sind für die String relevant

    Dim sek As String, min As String, hour As String 'bilden lblTime

#Region "MenuStripItems"
    Private Sub StopuhrToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles StopuhrToolStripMenuItem.Click
        Dim frmStopTimer As New frmStoptimer()
        frmStopTimer.Show()
        Me.Hide()
    End Sub

    Private Sub BeendenToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles BeendenToolStripMenuItem.Click
        Application.Exit()
    End Sub

    Private Sub btnStart_Click(sender As Object, e As EventArgs) Handles btnStart.Click
        tmr.Start()
    End Sub

    Private Sub EinstellungenToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles EinstellungenToolStripMenuItem.Click
        Dim frmOpt As New frmOption
        frmOpt.frm = "frmTimer"
        frmOpt.Show()
        Me.Hide()
    End Sub

    Private Sub itmClock_Click(sender As Object, e As EventArgs) Handles itmClock.Click
        Dim clock As New frmClock()
        clock.Show()
        Me.Hide()
    End Sub
#End Region

    Private Sub tmr_Tick(sender As Object, e As EventArgs) Handles tmr.Tick 'wenn tmr tickt
        intsek -= 1

        If intsek = -1 Then
            intsek = 0
        End If

        timerupdate()

        If intsek = 0 Then
            If intmin = 0 Then
                If inthour = 0 Then
                    player()
                    tmr.Stop()
                    intsek = 0
                    intmin = 0
                    inthour = 0
                    sek = ""
                    min = ""
                    hour = ""

                    lblTime.Text = "00:00:00"
                End If
            End If
        End If
        timetext()
    End Sub

    Private Sub frmtimer_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing 'wenn die Form gschlossen wird, wird die ganze Applikation beendet
        Application.Exit()
    End Sub

    Sub timetext() 'sek, min und hour werden hier zugewiesen durch intsek, intmin und inthour: bilden lbltime bei jeden Tick neu

        If intsek < 10 Then
            sek = "0" & CStr(intsek)
        Else
            sek = CStr(intsek)
        End If

        If intmin < 10 Then
            min = "0" & CStr(intmin)
        Else
            min = CStr(intmin)
        End If

        If inthour < 10 Then
            hour = "0" & CStr(inthour)
        Else
            hour = CStr(inthour)
        End If

        lblTime.Text = hour & ":" & min & ":" & sek
    End Sub

    Sub timerupdate() 'hier werden die Berechnungen für die Integer berechnet
        If intsek = 0 Then
            If intmin > 0 Then
                intmin -= 1
                intsek = 59
            End If
        End If

        If intmin = 0 Then
            If inthour > 0 Then
                intmin = 59
                inthour -= 1
            End If
        End If
    End Sub

    Sub player() 'SoundPlayer
        Dim player As New SoundPlayer
        player.Stream = My.Resources.Wecker_klingeln

        player.Load()
        player.Play()

        player.Dispose()
    End Sub

    Public Sub frmtimer_Load(sender As Object, e As EventArgs) Handles MyBase.Load 'wenn die Form geladen wird werden die Integer den Einstellungen zugewiesen
        intsek = My.Settings.sek
        intmin = My.Settings.min
        inthour = My.Settings.hour
    End Sub

    Public Sub btnStop_Click(sender As Object, e As EventArgs) Handles btnStop.Click 'wenn btnStop gedrückt wird
        tmr.Stop()
        My.Computer.Audio.Stop()
    End Sub

    Public Sub btnReset_Click(sender As Object, e As EventArgs) Handles btnReset.Click 'wenn btnReset gedrückt wird
        tmr.Stop()
        intsek = 0
        intmin = 0
        inthour = 0
        sek = ""
        min = ""
        hour = ""

        lblTime.Text = "00:00:00"
    End Sub
End Class
